Index: branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90
===================================================================
--- branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7576)
+++ branches/ORCHIDEE_2_2/ORCHIDEE/src_sechiba/routing.f90	(revision 7709)
@@ -1598,5 +1666,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., precip_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (precip_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE(humrel_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for humrel_mean','','')
@@ -1606,5 +1674,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., humrel_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (humrel_mean, val_exp, 'NO_KEYWORD', un)
-    
+
     ALLOCATE(k_litt_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for k_litt_mean','','')
@@ -1614,5 +1682,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., k_litt_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (k_litt_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE(totnobio_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for totnobio_mean','','')
@@ -1622,5 +1690,5 @@
     CALL restget_p (rest_id, var_name, nbp_glo, 1, 1, kjit, .TRUE., totnobio_mean, "gather", nbp_glo, index_g)
     CALL setvar_p (totnobio_mean, val_exp, 'NO_KEYWORD', zero)
-    
+
     ALLOCATE(vegtot_mean(nbpt), stat=ier)
     IF (ier /= 0) CALL ipslerr_p(3,'routing_init','Pb in allocate for vegtot_mean','','')
@@ -1693,9 +1761,14 @@
     IF (ALLOCATED(hydrodiag_loc)) DEALLOCATE(hydrodiag_loc)
     IF (ALLOCATED(hydrodiag_glo)) DEALLOCATE(hydrodiag_glo)
-    IF (ALLOCATED(hydroupbasin_loc)) DEALLOCATE(hydroupbasin_loc)    
+    IF (ALLOCATED(hydroupbasin_loc)) DEALLOCATE(hydroupbasin_loc)
     IF (ALLOCATED(hydroupbasin_glo)) DEALLOCATE(hydroupbasin_glo)
     IF (ALLOCATED(hydrographs)) DEALLOCATE(hydrographs)
     IF (ALLOCATED(slowflow_diag)) DEALLOCATE(slowflow_diag)
     IF (ALLOCATED(irrigation_mean)) DEALLOCATE(irrigation_mean)
+    IF (ALLOCATED(irrigdeficit_mean)) DEALLOCATE(irrigdeficit_mean)!
+    IF (ALLOCATED(irrigadduct_mean)) DEALLOCATE(irrigadduct_mean)!
+    IF (ALLOCATED(irrig_gw_source_mean)) DEALLOCATE(irrig_gw_source_mean) !
+    IF (ALLOCATED(irrig_fast_source_mean)) DEALLOCATE(irrig_fast_source_mean) !
+    IF (ALLOCATED(irrig_str_source_mean)) DEALLOCATE(irrig_str_source_mean) !
     IF (ALLOCATED(irrigated)) DEALLOCATE(irrigated)
     IF (ALLOCATED(floodplains)) DEALLOCATE(floodplains)
@@ -1718,9 +1791,9 @@
 !!
 !! DESCRIPTION (definitions, functional, design, flags) :
-!! This will first compute the amount of water which flows out of each of the 3 reservoirs using the assumption of an 
-!! exponential decrease of water in the reservoir (see Hagemann S and Dumenil L. (1998)). Then we compute the fluxes 
-!! for floodplains and ponds. All this will then be used in order to update each of the basins : taking water out of 
+!! This will first compute the amount of water which flows out of each of the 3 reservoirs using the assumption of an
+!! exponential decrease of water in the reservoir (see Hagemann S and Dumenil L. (1998)). Then we compute the fluxes
+!! for floodplains and ponds. All this will then be used in order to update each of the basins : taking water out of
 !! the up-stream basin and adding it to the down-stream one.
-!! As this step happens globaly we have to stop the parallel processing in order to exchange the information. Once 
+!! As this step happens globaly we have to stop the parallel processing in order to exchange the information. Once
 !! all reservoirs are updated we deal with irrigation. The final step is to compute diagnostic fluxes. Among them
 !! the hydrographs of the largest rivers we have chosen to monitor.
@@ -1778,9 +1851,11 @@
 !_ ================================================================================================================================
 
-  SUBROUTINE routing_flow(nbpt, dt_routing, lalo, floodout, runoff, drainage, &
+  SUBROUTINE routing_flow(nbpt, dt_routing, lalo, floodout, runoff, drainage, root_deficit, soiltile, &
        &                  vegtot, totnobio, transpot_mean, precip, humrel, k_litt, floodtemp, reinf_slope, &
-       &                  lakeinflow, returnflow, reinfiltration, irrigation, riverflow, &
+       &                  lakeinflow, returnflow, reinfiltration, irrig_frac, irrigation, irrigdeficit, &
+       &                  irrigadduct, irrig_gw_source, &
+       &                  irrig_fast_source, irrig_str_source, riverflow, & !
        &                  coastalflow, hydrographs, slowflow_diag, flood_frac, flood_res, &
-                          netflow_stream_diag, netflow_fast_diag, netflow_slow_diag)
+                          netflow_stream_diag, netflow_fast_diag, netflow_slow_diag, fraction_aeirrig_sw) !
     !
     IMPLICIT NONE
@@ -1793,4 +1868,5 @@
     REAL(r_std), INTENT(in)                      :: floodout(nbpt)            !! Grid-point flow out of floodplains (kg/m^2/dt)
     REAL(r_std), INTENT(in)                      :: drainage(nbpt)            !! Grid-point drainage (kg/m^2/dt)
+    REAL(r_std), INTENT(in)                      :: root_deficit(nbpt)        !! soil water deficit
     REAL(r_std), INTENT(in)                      :: vegtot(nbpt)              !! Potentially vegetated fraction (unitless;0-1)
     REAL(r_std), INTENT(in)                      :: totnobio(nbpt)            !! Other areas which can not have vegetation
@@ -1802,4 +1878,8 @@
     REAL(r_std), INTENT(in)                      :: reinf_slope(nbpt)         !! Coefficient which determines the reinfiltration ratio in the grid box due to flat areas (unitless;0-1)
     REAL(r_std), INTENT(out)                     :: lakeinflow(nbpt)          !! Water inflow to the lakes (kg/dt)
+    REAL(r_std), INTENT(in)                      :: soiltile(nbpt,nstm)       !! Fraction of each soil tile within vegtot (0-1, unitless)
+    REAL(r_std), INTENT(in)                      :: irrig_frac(nbpt)          !! Irrig. fraction interpolated in routing, and saved to pass to slowproc if irrigated_soiltile = .TRUE.
+    REAL(r_std), INTENT(in)                      :: fraction_aeirrig_sw(nbpt) !! Fraction of area equipped for irrigation from surface water, of irrig_frac
+
     !
 !! OUTPUT VARIABLES
@@ -1808,4 +1888,7 @@
     REAL(r_std), INTENT(out)                     :: reinfiltration(nbpt)      !! Water flow from ponds and floodplains which returns to the grid box (kg/m^2/dt)
     REAL(r_std), INTENT(out)                     :: irrigation(nbpt)          !! Irrigation flux. This is the water taken from the reservoirs and beeing put into the upper layers of the soil (kg/m^2/dt_routing)
+    REAL(r_std), INTENT(out)                     :: irrigdeficit(nbpt)          !! Irrigation deficit. Difference btw irrig. demand and irrigation
+    REAL(r_std), INTENT(out)                     :: irrigadduct(nbpt)          !! Irrigation from adducted water. Included in irrigation
+
     REAL(r_std), INTENT(out)                     :: riverflow(nbpt)           !! Outflow of the major rivers. The flux will be located on the continental grid but this should be a coastal point (kg/dt_routing)
     REAL(r_std), INTENT(out)                     :: coastalflow(nbpt)         !! Outflow on coastal points by small basins. This is the water which flows in a disperse way into the ocean (kg/dt_routing)
@@ -1818,4 +1901,8 @@
     REAL(r_std), INTENT(out)                     :: netflow_fast_diag(nbpt)   !! Input - Output flow to fast reservoir
     REAL(r_std), INTENT(out)                     :: netflow_slow_diag(nbpt)   !! Input - Output flow to slow reservoir
+
+    REAL(r_std), INTENT(out)                     :: irrig_gw_source(nbpt)     !! Irrigation from  groundwater per cell
+    REAL(r_std), INTENT(out)                     :: irrig_fast_source(nbpt)     !! Irrigation from  fast reservoir per cell
+    REAL(r_std), INTENT(out)                     :: irrig_str_source(nbpt)     !! Irrigation from  stramflow per cell
     !
 !! LOCAL VARIABLES
@@ -1843,8 +1930,8 @@
     REAL(r_std), DIMENSION(nbpt)                 :: totarea                   !! Total area of basin (m^2)
     REAL(r_std), DIMENSION(nbpt)                 :: totflood                  !! Total amount of water in the floodplains reservoir (kg)
-    REAL(r_std), DIMENSION(nbasmax)              :: pond_excessflow           !! 
+    REAL(r_std), DIMENSION(nbasmax)              :: pond_excessflow           !!
     REAL(r_std)                                  :: flow                      !! Outflow computation for the reservoirs (kg/dt)
     REAL(r_std)                                  :: floodindex                !! Fraction of grid box area inundated (unitless;0-1)
-    REAL(r_std)                                  :: pondex                    !! 
+    REAL(r_std)                                  :: pondex                    !!
     REAL(r_std)                                  :: flood_frac_pot            !! Total fraction of the grid box which is flooded at optimum repartition (unitless;0-1)
     REAL(r_std)                                  :: stream_tot                !! Total water amount in the stream reservoirs (kg)
@@ -1855,10 +1942,16 @@
     REAL(r_std)                                  :: total_lake_overflow       !! Sum of lake_overflow over full grid (kg)
     REAL(r_std), DIMENSION(8,nbasmax)            :: streams_around            !! Stream reservoirs of the neighboring grid boxes (kg)
-    INTEGER(i_std), DIMENSION(8)                 :: igrd                      !! 
-    INTEGER(i_std), DIMENSION(2)                 :: ff                        !! 
-    INTEGER(i_std), DIMENSION(1)                 :: fi                        !! 
+    INTEGER(i_std), DIMENSION(8)                 :: igrd                      !!
+    INTEGER(i_std), DIMENSION(2)                 :: ff                        !!
+    INTEGER(i_std), DIMENSION(1)                 :: fi                        !!
     INTEGER(i_std)                               :: ig, ib, ib2, ig2          !! Indices (unitless)
     INTEGER(i_std)                               :: rtg, rtb, in              !! Indices (unitless)
-    INTEGER(i_std)                               :: ier                       !! Error handling 
+    INTEGER(i_std)                               :: ier                       !! Error handling
+    REAL(r_std), DIMENSION(nbpt)              :: Count_failure_slow        !! Counter times slow reserv. does not fit irrigation demand
+    REAL(r_std), DIMENSION(nbpt)              :: Count_failure_fast        !! Counter times fast reserv. does not fit irrigation demand
+    REAL(r_std), DIMENSION(nbpt)              :: Count_failure_stre        !! Counter times stream reserv. does not fit irrigation demand
+    LOGICAL              :: IsFail_slow        !! Logical to ask if slow reserv. does not fit irrigation demand
+    LOGICAL              :: IsFail_fast        !! Logical to ask if fast reserv. does not fit irrigation demand
+    LOGICAL              :: IsFail_stre        !! Logical to ask if stream reserv. does not fit irrigation demand
     REAL(r_std), ALLOCATABLE, DIMENSION(:,:)     :: fast_flow_g               !! Outflow from the fast reservoir (kg/dt)
     REAL(r_std), ALLOCATABLE, DIMENSION(:,:)     :: slow_flow_g               !! Outflow from the slow reservoir (kg/dt)
@@ -1872,5 +1965,7 @@
     REAL(r_std), DIMENSION(nbpt, nbasmax)        :: netflow_slow              !! Input - Output flow to slow reservoir
 
-
+    REAL(r_std)                :: pcent_vol_irrig               !! Percentage of surface water for irrigation from total available water
+    REAL(r_std)                :: slow_wdr_dummy,fast_wdr_dummy,stre_wdr_dummy !! Dummy variables, real abstraction in each reservoir for irrigation
+    REAL(r_std)                :: pot_slow_wdr_dummy,pot_fast_wdr_dummy,pot_stre_wdr_dummy !! Dummy variables, potential abstraction in each reservoir for irrigatio
     !! PARAMETERS
     LOGICAL, PARAMETER                           :: check_reservoir = .FALSE. !! Logical to choose if we write informations when a negative amount of water is occurring in a reservoir (true/false)
@@ -1886,4 +1981,10 @@
     totarea(:) = zero
     totflood(:) = zero
+    irrig_gw_source(:) = zero !
+    irrig_fast_source(:) = zero !
+    irrig_str_source(:) = zero !
+    Count_failure_slow(:) = zero !
+    Count_failure_fast(:) = zero !
+    Count_failure_stre(:) = zero !
     !
     ! Compute all the fluxes
@@ -1897,5 +1998,5 @@
     ENDDO
           !
-!> The outflow fluxes from the three reservoirs are computed. 
+!> The outflow fluxes from the three reservoirs are computed.
 !> The outflow of volume of water Vi into the reservoir i is assumed to be linearly related to its volume.
 !> The water travel simulated by the routing scheme is dependent on the water retention index topo_resid
@@ -1912,5 +2013,5 @@
           IF ( route_tobasin(ig,ib) .GT. 0 ) THEN
              !
-             ! Each of the fluxes is limited by the water in the reservoir and a small margin 
+             ! Each of the fluxes is limited by the water in the reservoir and a small margin
              ! (min_reservoir) to avoid rounding errors.
              !
@@ -1923,5 +2024,5 @@
              slow_flow(ig,ib) = MAX(flow, zero)
 
-             flow = MIN(stream_reservoir(ig,ib)/((topo_resid(ig,ib)/1000.)*stream_tcst* & 
+             flow = MIN(stream_reservoir(ig,ib)/((topo_resid(ig,ib)/1000.)*stream_tcst* &
                   & MAX(un-SQRT(flood_frac_bas(ig,ib)),min_sechiba)*one_day/dt_routing),&
                   & stream_reservoir(ig,ib)-min_sechiba)
@@ -1944,5 +2045,5 @@
              flow = MIN(floodout(ig)*totarea(ig)*pond_frac(ig)/flood_frac(ig), pond_reservoir(ig)+totflood(ig))
              pondex = MAX(flow - pond_reservoir(ig), zero)
-             pond_reservoir(ig) = pond_reservoir(ig) - (flow - pondex) 
+             pond_reservoir(ig) = pond_reservoir(ig) - (flow - pondex)
              !
              ! If demand was over reservoir size, we will take it out from floodplains
@@ -1981,5 +2082,5 @@
     !-
     !- Computing the drainage and outflow from floodplains
-!> Drainage from floodplains is depending on a averaged conductivity (k_litt) 
+!> Drainage from floodplains is depending on a averaged conductivity (k_litt)
 !> for saturated infiltration in the 'litter' layer. Flood_drainage will be
 !> a component of the total reinfiltration that leaves the routing scheme.
@@ -1997,5 +2098,5 @@
           DO ib=1,nbasmax
              DO ig=1,nbpt
-                flood_drainage(ig,ib) = zero 
+                flood_drainage(ig,ib) = zero
              ENDDO
           ENDDO
@@ -2045,5 +2146,5 @@
              pond_drainage(ig,ib) = MIN(pond_reservoir(ig)*routing_area(ig,ib)/totarea(ig), &
                   & pond_frac(ig)*routing_area(ig,ib)*k_litt(ig)*dt_routing/one_day)
-             fast_flow(ig,ib) = fast_flow(ig,ib) - pond_inflow(ig,ib) 
+             fast_flow(ig,ib) = fast_flow(ig,ib) - pond_inflow(ig,ib)
           ENDDO
        ENDDO
@@ -2073,5 +2174,5 @@
     ENDIF
     IF (ier /= 0) CALL ipslerr_p(3,'routing_flow','Pb in allocate for fast_flow_g','','')
-       
+
     CALL gather(fast_flow,fast_flow_g)
     CALL gather(slow_flow,slow_flow_g)
@@ -2092,5 +2193,5 @@
 
     DEALLOCATE( fast_flow_g, slow_flow_g, stream_flow_g )
-   
+
     CALL scatter(transport_glo,transport)
 
@@ -2112,5 +2213,5 @@
        DO ib=1,nbasmax
           DO ig=1,nbpt
-             potflood(ig,ib) = transport(ig,ib) 
+             potflood(ig,ib) = transport(ig,ib)
              !
              IF ( tobeflooded(ig) > 0. .AND. potflood(ig,ib) > 0. .AND. floodtemp(ig) > tp_00 ) THEN
@@ -2123,5 +2224,5 @@
                 return_swamp(ig,ib) = swamp_cst * potflood(ig,ib) * floodindex
                 !
-                tobeflooded(ig) = tobeflooded(ig) - routing_area(ig,ib) 
+                tobeflooded(ig) = tobeflooded(ig) - routing_area(ig,ib)
                 !
              ENDIF
@@ -2136,5 +2237,5 @@
           IF (floodplains(ig) .GT. min_sechiba .AND. floodtemp(ig) .GT. tp_00) THEN
              DO ib=1,nbasmax
-                floods(ig,ib) = transport(ig,ib) - return_swamp(ig,ib) 
+                floods(ig,ib) = transport(ig,ib) - return_swamp(ig,ib)
              ENDDO
           ENDIF
@@ -2162,5 +2263,5 @@
           !
           flood_reservoir(ig,ib) = flood_reservoir(ig,ib) + floods(ig,ib) - &
-               & flood_flow(ig,ib) 
+               & flood_flow(ig,ib)
           !
           pond_reservoir(ig) = pond_reservoir(ig) + pond_inflow(ig,ib) - pond_drainage(ig,ib)
@@ -2170,5 +2271,5 @@
                 WRITE(numout,*) "WARNING : negative flood reservoir at :", ig, ib, ". Problem is being corrected."
                 WRITE(numout,*) "flood_reservoir, floods, flood_flow : ", flood_reservoir(ig,ib), floods(ig,ib), &
-                     & flood_flow(ig,ib) 
+                     & flood_flow(ig,ib)
              ENDIF
              stream_reservoir(ig,ib) = stream_reservoir(ig,ib) + flood_reservoir(ig,ib)
@@ -2229,5 +2330,5 @@
              flood_frac_pot = (totflood(ig) / (totarea(ig)*floodcri/(beta+un)))**(beta/(beta+un))
              flood_frac(ig) = MIN(floodplains(ig) / totarea(ig), flood_frac_pot)
-             ! Then we diagnose the fraction for each basin with the size of its flood_reservoir 
+             ! Then we diagnose the fraction for each basin with the size of its flood_reservoir
              ! (flood_frac_bas may be > 1)
              DO ib=1,nbasmax
@@ -2238,7 +2339,7 @@
              ENDDO
              ! We diagnose the maximum height of floodplain
-             flood_height(ig) = (beta/(beta+1))*floodcri*(flood_frac(ig))**(un/beta) + totflood(ig)/(totarea(ig)*flood_frac(ig)) 
+             flood_height(ig) = (beta/(beta+1))*floodcri*(flood_frac(ig))**(un/beta) + totflood(ig)/(totarea(ig)*flood_frac(ig))
              ! And finally add the pond surface
-             pond_frac(ig) = MIN(un-flood_frac(ig), ((betap+1)*pond_reservoir(ig) / (pondcri*totarea(ig)))**(betap/(betap+1)) ) 
+             pond_frac(ig) = MIN(un-flood_frac(ig), ((betap+1)*pond_reservoir(ig) / (pondcri*totarea(ig)))**(betap/(betap+1)) )
              flood_frac(ig) = flood_frac(ig) + pond_frac(ig)
              !
@@ -2265,5 +2366,5 @@
           DO ig=1,nbpt
              returnflow(ig) =  returnflow(ig) + return_swamp(ig,ib)
-             reinfiltration(ig) =  reinfiltration(ig) + pond_drainage(ig,ib) + flood_drainage(ig,ib) 
+             reinfiltration(ig) =  reinfiltration(ig) + pond_drainage(ig,ib) + flood_drainage(ig,ib)
           ENDDO
        ENDDO
